<template>
  <button
    class="shared-btn-favorite rounded-md w-6 h-6 flex items-center justify-center z-[19]"
    :class="{
      active: checkIsFavourite(game.GameId),
      [`favorite-style-${buttonStyle}`]: true,
      'd-shared-btn-favorite': useIsDesktop(),
    }"
    @click.prevent.stop="onToggleFavorite"
  >
    <IconHeartOutlined class="w-5 h-5 favorite__icon-inactive" />
    <IconHeartFilled class="w-5 h-5 favorite__icon-active" />
  </button>
</template>

<script setup lang="ts">
/**
 * TODO: Will use this compoent in every place later.
 */
import IconHeartOutlined from "~~/assets/icons/heart-outlined.svg?component";
import IconHeartFilled from "~~/assets/icons/heart-filled.svg?component";
import { GameBsi } from "~~/models/bsiGameList";
import { store } from "~~/store";

const props = withDefaults(
  defineProps<{
    game: GameBsi;
    index: number;
    buttonStyle?: "one" | "two";
  }>(),
  {
    buttonStyle: "one",
  }
);

const isAuthenticated = computed(() => store.state.auth);

const { toggleLoginRegisterDialog } = commonHelper;

const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
  useAddToFavorite();

const onToggleFavorite = () => {
  if (!isAuthenticated.value) {
    if (!useIsDesktop()) {
      toggleLoginRegisterDialog();
    } else {
      redirectToLogin();
    }

    return;
  }
  const isCurrentlyFavourite = checkIsFavourite(props.game.GameId);
  setAndUnsetGameToFavourite(props.game, !isCurrentlyFavourite, props.index);
};
</script>

<style lang="scss">
.btn-favorite-wrapper {
  &:hover {
    .shared-btn-favorite.d-shared-btn-favorite {
      top: 8px;
    }
  }
}

.shared-btn-favorite {
  --active-favorite-color: rgba(255, 255, 255, 1);
  --active-favorite-bg-color: rgba(242, 116, 139, 1);
  --bg-favorite-bg-color: rgba(242, 116, 139, 0.2);
  --favorite-size: 20px;

  background: var(--bg-favorite-bg-color);

  &.favorite-style-two {
    --active-favorite-color: rgba(242, 116, 139, 1);
    --active-favorite-bg-color: rgba(249, 209, 216, 0.2);
    --bg-favorite-bg-color: rgba(255, 255, 255, 0.2);

    background: var(--bg-favorite-bg-color);
  }

  @apply transition-all;

  .favorite__icon-active,
  .favorite__icon-inactive {
    @apply transition-all;
  }

  &.d-shared-btn-favorite {
    @apply top-2 right-2 w-8 h-8;

    .favorite__icon-active,
    .favorite__icon-inactive {
      @apply w-6 h-6;
    }

    &:not(.active) {
      @apply -top-8;

      &:hover {
        background: rgba(242, 116, 139, 0.50);
      }
    }

    &.active {
      animation: favouriteAnimation 1s ease-in-out;

      .favorite__icon-inactive {
        display: none;
      }

      .favorite__icon-active {
        animation: favouriteIconDesktopAnimation 1s ease-in-out;
      }
    }
  }

  .favorite__icon-active {
    color: var(--active-favorite-color);
  }

  &.active {
    animation: favouriteAnimation 1s ease-in-out;

    .favorite__icon-inactive {
      display: none;
    }

    .favorite__icon-active {
      animation: favouriteIconAnimation 1s ease-in-out;
    }
  }

  &:not(.active) {
    .favorite__icon-active {
      display: none;
    }
  }
}

@keyframes favouriteIconDesktopAnimation {
  0% {
    width: 16px;
    height: 16px;
  }

  10% {
    width: 16px;
    height: 16px;
  }

  26% {
    width: 28px;
    height: 28px;
  }

  36% {
    width: 24px;
    height: 24px;
  }

  46% {
    width: 28px;
    height: 28px;
  }

  56% {
    width: 24px;
    height: 24px;
  }

  100% {
    width: 24px;
    height: 24px;
  }
}

@keyframes favouriteAnimation {
  0% {
    background: var(--bg-favorite-bg-color);
  }

  10% {
    background: var(--active-favorite-bg-color);
  }

  66% {
    background: var(--active-favorite-bg-color);
  }

  100% {
    background: var(--bg-favorite-bg-color);
  }
}

@keyframes favouriteIconAnimation {
  0% {
    width: calc(var(--favorite-size) - 6px);
    height: calc(var(--favorite-size) - 6px);
  }

  10% {
    width: calc(var(--favorite-size) - 6px);
    height: calc(var(--favorite-size) - 6px);
  }

  26% {
    width: calc(var(--favorite-size) + 4px);
    height: calc(var(--favorite-size) + 4px);
  }

  36% {
    width: var(--favorite-size);
    height: var(--favorite-size);
  }

  46% {
    width: calc(var(--favorite-size) + 4px);
    height: calc(var(--favorite-size) + 4px);
  }

  56% {
    width: var(--favorite-size);
    height: var(--favorite-size);
  }

  100% {
    width: var(--favorite-size);
    height: var(--favorite-size);
  }
}
</style>
